Loading...
Searching...
No Matches
BaseStencil< DerivedType, GridT, IsSafe > Class Template Reference

`#include <openvdb/math/Stencils.h>`

Inheritance diagram for BaseStencil< DerivedType, GridT, IsSafe >:

## Public Types

typedef GridT | GridType
typedef GridT::TreeType | TreeType
typedef GridT::ValueType | ValueType
typedef tree::ValueAccessor< const TreeType, IsSafe > | AccessorType
typedef std::vector< ValueType > | BufferType
typedef BufferType::iterator | IterType

## Public Member Functions

void | moveTo (const Coord &ijk)
| Initialize the stencil buffer with the values of voxel (i, j, k) and its neighbors.
void | moveTo (const Coord &ijk, const ValueType &centerValue)
| Initialize the stencil buffer with the values of voxel (i, j, k) and its neighbors. The method also takes a value of the center element of the stencil, assuming it is already known.
template<typename IterType>
void | moveTo (const IterType &iter)
| Initialize the stencil buffer with the values of voxel (x, y, z) and its neighbors.
template<typename RealType>
void | moveTo (const Vec3< RealType > &xyz)
| Initialize the stencil buffer with the values of voxel (x, y, z) and its neighbors.
const ValueType & | getValue (unsigned int pos=0) const
| Return the value from the stencil buffer with linear offset pos.
template<int i, int j, int k>
const ValueType & | getValue () const
| Return the value at the specified location relative to the center of the stencil.
template<int i, int j, int k>
void | setValue (const ValueType &value)
| Set the value at the specified location relative to the center of the stencil.
int | size ()
| Return the size of the stencil buffer.
ValueType | median () const
| Return the median value of the current stencil.
ValueType | mean () const
| Return the mean value of the current stencil.
ValueType | min () const
| Return the smallest value in the stencil buffer.
ValueType | max () const
| Return the largest value in the stencil buffer.
const Coord & | getCenterCoord () const
| Return the coordinates of the center point of the stencil.
const ValueType & | getCenterValue () const
| Return the value at the center of the stencil.
bool | intersects (const ValueType &isoValue=zeroVal< ValueType >()) const
| Return true if the center of the stencil intersects the iso-contour specified by the isoValue.
std::bitset< 6 > | intersectionMask (const ValueType &isoValue=zeroVal< ValueType >()) const
| Return true a bit-mask where the 6 bits indicates if the center of the stencil intersects the iso-contour specified by the isoValue.
const GridType & | grid () const
| Return a const reference to the grid from which this stencil was constructed.
const AccessorType & | accessor () const
| Return a const reference to the ValueAccessor associated with this Stencil.

## Protected Member Functions

| BaseStencil (const GridType &grid, int size)

## Protected Attributes

const GridType * | mGrid
AccessorType | mAcc
BufferType | mValues
Coord | mCenter

## Member Typedef Documentation

## AccessorType

template<typename DerivedType, typename GridT, bool IsSafe>

typedef tree::ValueAccessor<const TreeType, IsSafe> AccessorType

## BufferType

template<typename DerivedType, typename GridT, bool IsSafe>

typedef std::vector<ValueType> BufferType

## GridType

template<typename DerivedType, typename GridT, bool IsSafe>

typedef GridT GridType

## IterType

template<typename DerivedType, typename GridT, bool IsSafe>

typedef BufferType::iterator IterType

## TreeType

template<typename DerivedType, typename GridT, bool IsSafe>

typedef GridT::TreeType TreeType

## ValueType

template<typename DerivedType, typename GridT, bool IsSafe>

typedef GridT::ValueType ValueType

## Constructor & Destructor Documentation

## BaseStencil()

template<typename DerivedType, typename GridT, bool IsSafe>

BaseStencil | ( | const GridType & | grid,
|  | int | size )

inline protected

## Member Function Documentation

## accessor()

template<typename DerivedType, typename GridT, bool IsSafe>

const AccessorType & accessor | ( |  | ) | const

inline

Return a const reference to the ValueAccessor associated with this Stencil.

## getCenterCoord()

template<typename DerivedType, typename GridT, bool IsSafe>

const Coord & getCenterCoord | ( |  | ) | const

inline

Return the coordinates of the center point of the stencil.

## getCenterValue()

template<typename DerivedType, typename GridT, bool IsSafe>

const ValueType & getCenterValue | ( |  | ) | const

inline

Return the value at the center of the stencil.

## getValue() [1/2]

template<typename DerivedType, typename GridT, bool IsSafe>
template<int i, int j, int k>

const ValueType & getValue | ( |  | ) | const

inline

Return the value at the specified location relative to the center of the stencil.

## getValue() [2/2]

template<typename DerivedType, typename GridT, bool IsSafe>

const ValueType & getValue | ( | unsigned int | pos = 0 | ) | const

inline

Return the value from the stencil buffer with linear offset pos.

Note
  The default (pos = 0) corresponds to the first element which is typically the center point of the stencil.

## grid()

template<typename DerivedType, typename GridT, bool IsSafe>

const GridType & grid | ( |  | ) | const

inline

Return a const reference to the grid from which this stencil was constructed.

## intersectionMask()

template<typename DerivedType, typename GridT, bool IsSafe>

std::bitset< 6 > intersectionMask | ( | const ValueType & | isoValue = zeroVal<ValueType>() | ) | const

inline

Return true a bit-mask where the 6 bits indicates if the center of the stencil intersects the iso-contour specified by the isoValue.

Note
  There are 2^6 = 64 different possible cases, including no intersections!

The ordering of bit mask is ( -x, +x, -y, +y, -z, +z ), so to check if there is an intersection in -y use mask.test(2) where mask is ther return value from this function. To check if there are any intersections use mask.any(), and for no intersections use mask.none(). To count the number of intersections use mask.count().

## intersects()

template<typename DerivedType, typename GridT, bool IsSafe>

bool intersects | ( | const ValueType & | isoValue = zeroVal<ValueType>() | ) | const

inline

Return true if the center of the stencil intersects the iso-contour specified by the isoValue.

## max()

template<typename DerivedType, typename GridT, bool IsSafe>

ValueType max | ( |  | ) | const

inline

Return the largest value in the stencil buffer.

## mean()

template<typename DerivedType, typename GridT, bool IsSafe>

ValueType mean | ( |  | ) | const

inline

Return the mean value of the current stencil.

## median()

template<typename DerivedType, typename GridT, bool IsSafe>

ValueType median | ( |  | ) | const

inline

Return the median value of the current stencil.

## min()

template<typename DerivedType, typename GridT, bool IsSafe>

ValueType min | ( |  | ) | const

inline

Return the smallest value in the stencil buffer.

## moveTo() [1/4]

template<typename DerivedType, typename GridT, bool IsSafe>

void moveTo | ( | const Coord & | ijk | ) |

inline

Initialize the stencil buffer with the values of voxel (i, j, k) and its neighbors.

Parameters

  ijk | Index coordinates of stencil center

## moveTo() [2/4]

template<typename DerivedType, typename GridT, bool IsSafe>

void moveTo | ( | const Coord & | ijk,
|  | const ValueType & | centerValue )

inline

Initialize the stencil buffer with the values of voxel (i, j, k) and its neighbors. The method also takes a value of the center element of the stencil, assuming it is already known.

Parameters

  ijk | Index coordinates of stnecil center
  centerValue | Value of the center element of the stencil

## moveTo() [3/4]

template<typename DerivedType, typename GridT, bool IsSafe>
template<typename IterType>

void moveTo | ( | const IterType & | iter | ) |

inline

Initialize the stencil buffer with the values of voxel (x, y, z) and its neighbors.

Note
  This version is slightly faster than the one above, since the center voxel's value is read directly from the iterator.

## moveTo() [4/4]

template<typename DerivedType, typename GridT, bool IsSafe>
template<typename RealType>

void moveTo | ( | const Vec3< RealType > & | xyz | ) |

inline

Initialize the stencil buffer with the values of voxel (x, y, z) and its neighbors.

Parameters

  xyz | Floating point voxel coordinates of stencil center

This method will check to see if it is necessary to update the stencil based on the cached index coordinates of the center point.

## setValue()

template<typename DerivedType, typename GridT, bool IsSafe>
template<int i, int j, int k>

void setValue | ( | const ValueType & | value | ) |

inline

Set the value at the specified location relative to the center of the stencil.

## size()

template<typename DerivedType, typename GridT, bool IsSafe>

int size | ( |  | ) |

inline

Return the size of the stencil buffer.

## Member Data Documentation

## mAcc

template<typename DerivedType, typename GridT, bool IsSafe>

AccessorType mAcc

protected

## mCenter

template<typename DerivedType, typename GridT, bool IsSafe>

Coord mCenter

protected

## mGrid

template<typename DerivedType, typename GridT, bool IsSafe>

const GridType* mGrid

protected

## mValues

template<typename DerivedType, typename GridT, bool IsSafe>

BufferType mValues

protected